import sys

from PyQt5.QtWidgets import QWidget, QTextEdit, QGridLayout, QPushButton, \
	QApplication, QMainWindow

from geniusweb.simplerunner.gui.SettingsPanel import SettingsPanel


class GUI (QWidget):
	'''
	Simple GUI allowing users to create the settings interactively, much like on
	the runserver
	'''

	def __init__(self):
		super().__init__()
		self.resultarea = QTextEdit()
		self.resultarea.setReadOnly(True)
		self.resultarea.setText("Results will appear here after run")
		# set dimension , 9, 40

		layout = QGridLayout()
		self.setLayout(layout)
	
		self.settingsPanel = SettingsPanel()
		layout.addWidget(self.settingsPanel)
		layout.addWidget(self.startPanel())

	def startPanel(self) -> QWidget:
		startpanel = QWidget()
		layout = QGridLayout()
		startpanel.setLayout(layout)
		
		startbutton = QPushButton()
		startbutton.setText("Start Session")
		layout.addWidget(startbutton)
		layout.addWidget(self.resultarea)

		this = self
		startbutton.clicked.connect(this.runsession)  # type:ignore
		return startpanel;

	def runsession(self, b):
		print("todo run")
 # 	resultarea.setText("");
 # 	Reporter myreporter = new Reporter() {
 #
 # 		@Override
 # 		public void log(Level level, String msg) {
 # 			resultarea.append("[" + level + "] " + msg + "\n");
 # 		}
 #
 # 		@Override
 # 		public void log(Level level, String msg, Throwable thrown) {
 # 			resultarea.append("[" + level + "] throws " + msg + "\n");
 # 			StringWriter errors = new StringWriter();
 # 			thrown.printStackTrace(new PrintWriter(errors));
 # 			resultarea.append(errors.toString() + "\n");
 # 		}
 # 	};
 # 	NegoRunner runner = new NegoRunner(settingsPanel.getSettings(),
 # 			new ClassPathConnectionFactory(), myreporter, 0);
 # 	runner.run();
 # }


if __name__ == '__main__':
    app = QApplication([])
  
    win = QMainWindow()
    win.setWindowTitle("GeniusWeb SimpleRunner GUI")
    win.setCentralWidget(GUI())
    win.show()
    sys.exit(app.exec_())

